
// ApkInstallerDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ApkInstaller.h"
#include "ApkInstallerDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CApkInstallerDlg Ի
static void Tokenize(CString text, CString split, CStringArray &list)
{
	CString partStr;
	int position = 0;
	do
	{
		partStr = text.Tokenize(split, position);
		if (partStr != T(""))
		{
			int offset = partStr.Find(T("device"));
			list.Add(partStr.Mid(0,offset).Trim());
		}
	} while (!partStr.IsEmpty());
}

static void GT_UTF8ToGBK(CString &strUTF8)  
{  
	//ȡתΪֽںҪĻСֽڻ
	UINT nLen = MultiByteToWideChar(CP_UTF8,NULL,strUTF8,-1,NULL,NULL);
	WCHAR *wszBuffer = new WCHAR[nLen+1];
	nLen = MultiByteToWideChar(CP_UTF8,NULL,strUTF8,-1,wszBuffer,nLen);
	wszBuffer[nLen] = 0;

	nLen = WideCharToMultiByte(CP_ACP,NULL,wszBuffer,-1,NULL,NULL,NULL,NULL);
	CHAR *szBuffer = new CHAR[nLen+1];
	nLen = WideCharToMultiByte(CP_ACP,NULL,wszBuffer,-1,szBuffer,nLen,NULL,NULL);
	szBuffer[nLen] = 0;  

	strUTF8 = szBuffer;
	//ڴ
	delete []szBuffer;
	delete []wszBuffer;
}

static CString ParseName(CString strProp,CString beginLabel,CString endLabel)
{
	int mPos = strProp.Find(beginLabel);
	if (mPos != -1)
	{
		mPos += beginLabel.GetLength();
		int mEnd = strProp.Find(endLabel,mPos);
		if(mEnd != -1)
		{
			return strProp.Mid(mPos,mEnd-mPos);
		}
	}
	return "";
}

//ƣAssociateApkFile
//ܣapkļͼ
//strType ļ  .apk .mpk
//     strPath · ļĿִгĴ·ļ
//  ֵNULL
//˵
static void AssociateFile(CString strType, CString strPath) {
	//HKEY_LOCAL_MACHINE/Software/Classes/HKEY_CLASSES_ROOT
	HKEY hkey;
	CString strKeyName("ITHTW");
	CString strResult("");
	LPBYTE OwnerGet = new BYTE[80]; //û
	memset(OwnerGet, 0, 80);
	DWORD dType1 = REG_SZ; //
	DWORD dLength = 80; //ݳ
	CString strValue("");
	CString strRegPath("");
	strRegPath = strType + "\\"; // .apk
	// ·"HKEY_CLASS_ROOT\\.apk"ļֵ.apkļ
	if (RegOpenKey(HKEY_CLASSES_ROOT, strRegPath, &hkey) == ERROR_SUCCESS) {
		RegQueryValueEx(hkey, NULL, NULL, &dType1, OwnerGet, &dLength);
		strResult = (LPTSTR) OwnerGet;
		if (-1 == strResult.Find(CString("ITHTW"))) {
			strValue.Format("ITHTW");
			RegSetValue(hkey, _T(""), REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	} else {
		if (RegCreateKey(HKEY_CLASSES_ROOT, strType, &hkey) != ERROR_SUCCESS) {
			return;
		} else {
			strValue.Format("ITHTW");
			RegSetValue(hkey, _T(""), REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	}
	// "SOFTWARE\\Classes\\.apk"ļֵ
	memset(OwnerGet, 0, 80);
	if (strResult.IsEmpty())
		strResult.Empty();
	strValue.Empty();
	strRegPath = CString("SOFTWARE\\Classes\\") + strType + "\\"; // SOFTWARE\\Classes\\.apk
	if ( RegOpenKey( HKEY_LOCAL_MACHINE, strRegPath, &hkey ) == ERROR_SUCCESS )
	{
		RegQueryValueEx(hkey, NULL, NULL, &dType1, OwnerGet, &dLength);
		strResult = (LPTSTR) OwnerGet;
		if (-1 == strResult.Find("ITHTW")) {
			// ùؼûҵ,޸֮
			strValue.Format("ITHTW");
			RegSetValue(hkey, _T(""), REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	}
	else
	{
		if ( RegCreateKey( HKEY_LOCAL_MACHINE, strRegPath, &hkey ) != ERROR_SUCCESS )
		{
			return;
		}
		else
		{
			strValue.Format("ITHTW");
			RegSetValue(hkey, _T(""), REG_SZ, strValue, strValue.GetLength()+1);
			RegSetValueEx(hkey, "", 0, REG_SZ, (const BYTE*)strValue.GetBuffer(strValue.GetLength()), strValue.GetLength()+1);
			RegCloseKey(hkey);
		}
	}
	// ·"HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\.apk\\UserChoice"ֵ
	memset(OwnerGet, 0, 80);
	if (strResult.IsEmpty())
		strResult.Empty();
	strValue.Empty();
	strRegPath =
		CString(
		"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\")
		+ strType + "\\UserChoice";
	if (RegOpenKey(HKEY_CURRENT_USER, strRegPath, &hkey) == ERROR_SUCCESS) {
		RegQueryValueEx(hkey, NULL, NULL, &dType1, OwnerGet, &dLength);
		strResult = (LPTSTR) OwnerGet;
		if (-1 == strResult.Find("ITHTW")) {
			// ùؼûҵ,޸֮
			strValue.Format("ITHTW");
			RegSetValue(hkey, "Progid", REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "Progid", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	} else {
		if (RegCreateKey(HKEY_CURRENT_USER, strRegPath, &hkey)
			!= ERROR_SUCCESS) {
				return;
		} else {
			strValue.Format("ITHTW");
			RegSetValue(hkey, "Progid", REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "Progid", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	}
	memset(OwnerGet, 0, 80);
	if (strResult.IsEmpty())
		strResult.Empty();
	strValue.Empty();
	strRegPath =
		CString(
		"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\")
		+ strType;
	if (RegOpenKey(HKEY_CURRENT_USER, strRegPath, &hkey) == ERROR_SUCCESS) {
		RegQueryValueEx(hkey, NULL, NULL, &dType1, OwnerGet, &dLength);
		strResult = (LPTSTR) OwnerGet;
		if (-1 == strResult.Find("ITHTW")) {
			// ùؼûҵ,޸֮
			strValue.Format("ITHTW");
			RegSetValue(hkey, "Progid", REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "Progid", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	} else {
		if (RegCreateKey(HKEY_CURRENT_USER, strRegPath, &hkey)
			!= ERROR_SUCCESS) {
				return;
		} else {
			strValue.Format("ITHTW");
			RegSetValue(hkey, "Progid", REG_SZ, strValue,
				strValue.GetLength() + 1);
			RegSetValueEx(hkey, "Progid", 0, REG_SZ,
				(const BYTE*) strValue.GetBuffer(strValue.GetLength()),
				strValue.GetLength() + 1);
			RegCloseKey(hkey);
		}
	}
	// ֪ͨϵͳļı
	SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, NULL, NULL);
	SHChangeNotify(SHCNE_UPDATEIMAGE, SHCNF_DWORD, NULL, NULL);
}

CApkInstallerDlg::CApkInstallerDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CApkInstallerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(szCommand,0,sizeof(szCommand));
	memset(szPath,0,sizeof(szPath));
	hEvent = CreateEvent(NULL,FALSE,TRUE,NULL);
}

void CApkInstallerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CApkInstallerDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_BTN_INSTALL, &CApkInstallerDlg::OnBnClickedBtnInstall)
	ON_BN_CLICKED(IDC_BTN_UNINSTALL, &CApkInstallerDlg::OnBnClickedBtnUninstall)
	ON_BN_CLICKED(IDC_BTN_REG, &CApkInstallerDlg::OnBnClickedBtnReg)
END_MESSAGE_MAP()


// CApkInstallerDlg Ϣ

CString ReadDeviceName(CString cmd)
{
	CApkInstallerDlg* dlg = (CApkInstallerDlg*)AfxGetApp()->GetMainWnd();
	char buffer[10240] = {0};
	DWORD dwRead = 0;
	HANDLE hReadPipe = NULL;
	dlg->ProcessTask(&hReadPipe,cmd.GetBuffer());
	cmd.ReleaseBuffer();
	CString text;
	while (ReadFile(hReadPipe,buffer,10240,&dwRead,0))
	{
		CString temp(buffer,dwRead);
		temp = temp.Trim();
		text += temp;
	}
	return text;
}

void CApkInstallerDlg::ReadDevices(void)
{
	_tcscpy_s(szCommand,T("adb devices"));
	//ʼȡ
	char buffer[10240] = {0};
	DWORD dwRead = 0;
	HANDLE hReadPipe = NULL;
	ProcessTask(&hReadPipe,szCommand);
	CString text;
	while (ReadFile(hReadPipe,buffer,10240,&dwRead,0))
	{
		CString temp(buffer,dwRead);
		temp = temp.Trim();
		text += temp;
	}
	Tokenize(text,T("\n"),devices);
	CComboBox *comboBox = (CComboBox*)GetDlgItem(IDC_COMBO_DEVICES);
	for (int i=1;i<devices.GetCount();i++)//˵һlistϢ
	{
		CString prop = ReadDeviceName("adb -s "+devices.GetAt(i)+" shell getprop");
		CString manufacturer = ParseName(prop,"[ro.product.manufacturer]: [","]");
		CString mode = ParseName(prop,"[ro.product.model]: [","]");
		comboBox->AddString(manufacturer+mode);
	}
	if(comboBox->GetCount() > 0)
		comboBox->SetCurSel(0);
}

BOOL CApkInstallerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ

	ReadDevices();
	SetDlgItemText(IDC_EDIT_LOG,T("־"));
	if(_tcslen(szPath) == 0)
		SetDlgItemText(IDC_EDIT_FILE,T("ļ·"));
	else
	{
		SetDlgItemText(IDC_EDIT_FILE,szPath);
		if (CheckApk(szPath))
		{
			//ȡ
			SetSzCommand(T("aapt d badging "),CMD_GET_READ_INFO);
			_tcscat_s(szCommand,szPath);
			AfxBeginThread(ReadThread,this);
		}
	}
	return TRUE;  // ǽõؼ򷵻 TRUE
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CApkInstallerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
		CRect rt;
		GetDlgItem(IDC_STATIC_ICO)->GetWindowRect(&rt);
		CPoint p(rt.left,rt.top);
		::ScreenToClient(m_hWnd,&p);

		CDC *pDC = GetDC();
		Graphics graphics(pDC->m_hDC);
		Image *img = NULL;
		ImageFromID(IDB_PNG_ANDROID,img);
		graphics.DrawImage(img,p.x-20,p.y);
		FontFamily fontFamily(L"΢ź");
		Gdiplus::Font font(&fontFamily, 11, FontStyleRegular, UnitPoint);
		PointF pointF((REAL)(p.x+10), (REAL)p.y+30);
		SolidBrush solidBrush(Color(255, 0, 0, 0)); 
		//TCHAR string[MAX_PATH] = T("װ");
		WCHAR string[MAX_PATH] = L"װ";
		graphics.DrawString(string, (INT)wcslen(string), &font, pointF,&solidBrush);
		if(img != NULL)
			delete img;
		ReleaseDC(pDC);
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CApkInstallerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CApkInstallerDlg::OnDropFiles(HDROP hDropInfo)
{
	// TODO: ڴϢ/Ĭֵ
	TCHAR file_name[MAX_PATH] = {0};
	::DragQueryFile(hDropInfo,0, file_name, MAX_PATH);
	SetDlgItemText(IDC_EDIT_FILE,file_name);
	if (CheckApk(file_name))
	{
		//ȡ
		SetSzCommand(T("aapt d badging "),CMD_GET_READ_INFO);
		_tcscat_s(szCommand,file_name);
		AfxBeginThread(ReadThread,this);
	}
	CDialogEx::OnDropFiles(hDropInfo);
}


UINT CApkInstallerDlg::ReadThread(LPVOID pVoid)
{
	try{
		CApkInstallerDlg *dlg = (CApkInstallerDlg*)pVoid;
		WaitForSingleObject(dlg->hEvent,INFINITE);
		dlg->SetWindowText(T(",Ժ..."));
		
		//ʼȡ
		char buffer[10240] = {0};
		DWORD dwRead = 0;
		HANDLE hReadPipe = NULL;
		dlg->ProcessTask(&hReadPipe,dlg->szCommand);
		CString text;
		while (ReadFile(hReadPipe,buffer,10240,&dwRead,0))
		{
			CString temp(buffer,dwRead);
			GT_UTF8ToGBK(temp);
			text += temp;
		}
		text.Trim();
		if (text.GetLength() > 0)
		{
			 if (dlg->nCommand == CMD_INSTALL_APP)
			{
				dlg->SetDlgItemText(IDC_EDIT_LOG,text);
			}
			else if (dlg->nCommand == CMD_GET_READ_INFO)
			{
				dlg->SetDlgItemText(IDC_EDIT_LOG,text);
				CString temp = T("package: name='");
				int startIndex = text.Find(temp);
				int endIndex = text.Find(T("'"),startIndex+temp.GetLength());
				int nCount = endIndex - startIndex - temp.GetLength();
				if(startIndex >= 0 && nCount > 0)
					dlg->packAge=text.Mid(startIndex+temp.GetLength(),nCount);
			}
			else if (dlg->nCommand == CMD_UNINSTALL)
			{
				if(hReadPipe != NULL)
					CloseHandle(hReadPipe);
				hReadPipe = NULL;
				dlg->ProcessTask(&hReadPipe,dlg->szCommand);
				if (ReadFile(hReadPipe,buffer,10240,&dwRead,0))
				{
					CString new_text(buffer,dwRead);
					new_text = new_text.Trim();
					dlg->SetDlgItemText(IDC_EDIT_LOG,new_text);
				}
			}
		}
		else
		{
			//̨ݶȡʧ
			strcpy_s(buffer,"ݶȡʧ");
		}
		CloseHandle(hReadPipe);
		dlg->SetWindowText(T(""));
		SetEvent(dlg->hEvent);
	}catch(CException *e)
	{
		TCHAR msg[512];
		e->GetErrorMessage(msg,512);
		AfxMessageBox(msg);
	}
	return 0;
}


UINT CApkInstallerDlg::ProcessTask(HANDLE* hReadPipe,TCHAR* strCommand)
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	si.cb = sizeof(STARTUPINFO);
	GetStartupInfo(&si);


	SECURITY_ATTRIBUTES sa = {0};
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = TRUE;
	sa.lpSecurityDescriptor = NULL;

	HANDLE hWritePipe = NULL;
	if(!CreatePipe(hReadPipe,&hWritePipe,&sa,0))
	{
		AfxMessageBox(T("ܵʧ"));
		return 0;
	}

	si.hStdOutput = hWritePipe;
	si.hStdError = hWritePipe;
	si.wShowWindow = SW_HIDE;
	si.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	if (CreateProcess (NULL,strCommand,NULL,NULL,TRUE,NULL,NULL,NULL,&si,&pi))
	{
		//ȴִ
		//WaitForSingleObject(pi.hProcess,INFINITE);
		//رս̺߳̾
		CloseHandle (pi.hProcess);
		CloseHandle (pi.hThread);
	}
	//رд
	CloseHandle(hWritePipe);
	return 0;
}

void CApkInstallerDlg::SetSzCommand(TCHAR* wstr,CMD_TYPE nType)
{
	memset(szCommand,0,sizeof(szCommand));
	_tcscpy_s(szCommand,wstr);
	this->nCommand = nType;
}


void CApkInstallerDlg::OnBnClickedBtnUninstall()
{
	// TODO: ڴӿؼ֪ͨ
	try
	{
		TCHAR file_name[512] = {0};
		GetDlgItemText(IDC_EDIT_FILE,file_name,512);
		if (CheckApk(file_name))
		{
			SetDlgItemText(IDC_EDIT_LOG,T("ж:")+packAge);
			//ж
			SetSzCommand(T("adb -s "),CMD_UNINSTALL);
			CComboBox *comboBox = (CComboBox*)GetDlgItem(IDC_COMBO_DEVICES);
			int cur = comboBox->GetCurSel();
			if (cur >= 0 && cur < devices.GetCount()-1)
			{
				CString device = devices.GetAt(cur+1);
				_tcscat_s(szCommand,device);
				_tcscat_s(szCommand,T(" uninstall "));
				_tcscat_s(szCommand,packAge);
				AfxBeginThread(ReadThread,this);
			}
		}
	}
	catch (CException* e)
	{
		TCHAR msg[512];
		e->GetErrorMessage(msg,512);
		MessageBox(msg);
	}
}

void CApkInstallerDlg::OnBnClickedBtnInstall()
{
	// TODO: ڴӿؼ֪ͨ
	try
	{
		TCHAR file_name[512] = {0};
		GetDlgItemText(IDC_EDIT_FILE,file_name,512);
		if (CheckApk(file_name))
		{
			SetDlgItemText(IDC_EDIT_LOG,T("ڰװ:")+CString(file_name));
			SetSzCommand(T("adb -s "),CMD_INSTALL_APP);
			CComboBox *comboBox = (CComboBox*)GetDlgItem(IDC_COMBO_DEVICES);
			int cur = comboBox->GetCurSel();
			if (cur >= 0 && cur < devices.GetCount()-1)
			{
				CString device = devices.GetAt(cur+1);
				_tcscat_s(szCommand,device);
				_tcscat_s(szCommand,T(" install "));
				_tcscat_s(szCommand,file_name);
				AfxBeginThread(ReadThread,this);
			}
		}
	}
	catch (CException* e)
	{
		TCHAR msg[512];
		e->GetErrorMessage(msg,512);
		MessageBox(msg);
	}
}


BOOL CApkInstallerDlg::CheckApk(TCHAR* path)
{
	try
	{
		TCHAR* exist = _tcsstr(path,T("apk"));
		if (exist == NULL)
		{
			MessageBox(T(""));
			return FALSE;
		}
		CFileFind finder;
		if(!finder.FindFile(path))
		{
			MessageBox(T("ָļ"));
			return FALSE;
		}
	}
	catch (CException* e)
	{
		TCHAR msg[512];
		e->GetErrorMessage(msg,512);
		MessageBox(msg);
	}
	return TRUE;
}

void CApkInstallerDlg::OnBnClickedBtnReg()
{
	// TODO: ڴӿؼ֪ͨ
	TCHAR szName[512];
	GetModuleFileName(NULL,szName,sizeof(szName)*sizeof(TCHAR));
	AssociateFile(".apk",szName);
}
